unit UGBLIB;

// Demonstration of COPYCRYPT32.DLL
// After first run, .CCR files will be registered to decode on double-click
// (To change CCR to your own extension, change the constant ENCEXT below)

// Command-line options: (program mostly not interactive in these modes)
// "PGBLIB.EXE filename"  = will prompt for a password and decode
// "PGBLIB.EXE filename password"  = will decode the file according to password
// Original code copyright (c)1997 gbamber@mistral.co.uk

interface

uses
// Make sure you have REGISTRY, SHELLAPI and COPYCRYPT in the uses clause
// COPYCRYPT32.DLL must be available to the program (ie the same directory or in PATH)
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, COPYCRYPT,Registry,ShellAPI;

type
  Tmainform = class(TForm)
    OpenDialog2: TOpenDialog;
    OpenDialog1: TOpenDialog;
    cmd_Encode: TButton;
    cmd_Decode: TButton;
    cmd_Close: TBitBtn;
    img_Progicon: TImage;
    lbl_Information: TLabel;
    procedure cmd_EncodeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmd_DecodeClick(Sender: TObject);
    procedure img_ProgiconMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cmd_CloseClick(Sender: TObject);
  private
    { Private declarations }
    Procedure EncodeAFile(AFile,APass:String);//Cut paste this routine for your own app//
    Procedure DecodeAFile(AFile,APass:String);//Cut paste this routine for your own app//

    //The procedure below is for Drag/Drop from Explorer//
    procedure WMDROPFILES(var Message: TWMDROPFILES); message WM_DROPFILES;

    Function InputQueryENC(Const APrompt,ACaption:String;Var APassword:String):Boolean;
    Function InputQueryDEC(Const APrompt,ACaption:String;Var APassword:String):Boolean;
  public
    { Public declarations }
  end;

CONST
     ENCEXT='.CCR';//CHANGE THIS HERE ONLY! IT AFFECTS MANY DIFFERENT STATEMENTS//
var
  mainform: Tmainform;
  CURRDIR:String;

  REG_DEFAULTPASSWORD:String;//Global default set from the registry//
  //HKEY_CURRENT_USER/Software/CopyCrypt/DefaultPassword
  REG_NOPROMPT:Boolean;//Global default set from the registry//
  //Edit + Double-click COPYCRPT.REG to use these//

implementation

{$R *.DFM}

// STARTOFPROGRAM //

(******************************************************************************)

Function TMainForm.InputQueryENC(Const APrompt,ACaption:String;Var APassword:String):Boolean;
BEGIN
//Set defaults//
APassword:=REG_DEFAULTPASSWORD;
Result:=True;
//Use the defaults and go?//
if REG_NOPROMPT then exit;

Result:=InputQuery(APrompt,ACaption,APassword)
END;

(******************************************************************************)

Function TMainForm.InputQueryDEC(Const APrompt,ACaption:String;Var APassword:String):Boolean;
BEGIN
APassword:=REG_DEFAULTPASSWORD;
Result:=True;
//Use the defaults and go?//
if REG_NOPROMPT then exit;

Result:=InputQuery(APrompt,ACaption,APassword)
END;

(******************************************************************************)

//Any files dropped onto the form get processed here//
//Many thanks to SWAG for the guts of this code//
procedure TMainForm.WMDROPFILES(var Message: TWMDROPFILES);
const
   cnmaxfilenamelen = 255;
var
   i,ncount : integer;
   acfilename : array [0..255] of char;
   ENCPassword,DECPassword:String;
   CurrExt,s:String;
   FileList:TSTRINGS;//Temporary//
BEGIN
//MainForm.Activate;
//MainForm.SetFocus;
FileList:=TStringList.Create;
 Try//Encase all this in a resource protection block//
  ncount := dragqueryfile (message.drop, $FFFFFFFF,acfilename,cnmaxfilenamelen);
  for i := 0 to ncount -1 do
   begin
    dragqueryfile (message.drop,i,acfilename,cnmaxfilenamelen);
    //acfilename is the PChar filename + path of the dropped file//
    s:=String(acfilename);
    //Don't add directories!//
    if ((FileGetAttr(s) and faDirectory) = faDirectory) then
    MessageDlg('A Directory was amongst the dragged items. I can only process files.',
    mtWarning,[MBOK],0)
    else FileList.Add(s);
    end;
  dragfinish(message.drop);

 //Now to process the items gathered in FileList//
 //These may be a mixture of files to encode, and files to decode//
//If the user cancels the InputQueries, then the Encode/Decode routines give them another chance
ENCPassword:='unknown';
DECPassword:='unknown';

For i:=0 to FileList.Count-1 do
 Begin
  //Check to see if it's an encoded file extension//
  CurrExt:=ExtractFileExt(FileList[i]);
  Application.ProcessMessages;
  //Deal with files to Decrypt here
  If CurrExt=ENCEXT then
   begin
    If DECPassWord='unknown' then
     InputQueryDEC('Authentication required for decryption','Type in the decryption password for ' + FileList[i],DECPassWord);
    // DEBUGGING MessageDlg(FileList[i],mtInformation,[MBOK],0);
    DecodeAFile(FileList[i],DECPassWord);
   end
   else
   //Deal with files to encrypt here
   begin
    If ENCPassWord='unknown' then
     InputQueryENC('Authentication required for encryption','Type in the encryption password for ' + FileList[i],ENCPassWord);
    // DEBUGGING MessageDlg(FileList[i],mtInformation,[MBOK],0);
    EncodeAFile(FileList[i],ENCPassWord);
   end;
 End;
 //FileList processing done. Free the StringList memory now.//
 Finally
  FileList.Free;
 end;
END;

(******************************************************************************)
// General routine that can be copied to any application that Encodes a file
Procedure TMainForm.EncodeAFile(AFile,APass:String);
Var
   s,password:String;
  passflag:Boolean;
BEGIN
 PassFlag:=True; // Assume success, look for failure

 // Get a password if no valid one was passed to the routine
 // If user cancels, then go no further
 if APass='unknown' then
  PassFlag:=InputQueryENC('Encryption Password Input','Choose an encryption password',password)
 else password:=APass;
 s:=AFile;
 If PassFlag then // Password supplied
    begin
     Screen.Cursor:=crHourGlass;
     Application.ProcessMessages;

     // Call COPYCRYPT.DLL here
     EncodeSingle(PChar(s),PChar(ChangeFileExt(s,ENCEXT)),PChar(password));
     Screen.Cursor:=crDefault;

    end;
END;

(******************************************************************************)

// General routine that can be copied to any application that decodes a file
Procedure TMainForm.DecodeAFile(AFile,APass:String);
Var
 s,password:String;
 i_Ret,i_RetFlag:Integer;
 passflag:Boolean;
BEGIN
 PassFlag:=True; // Assume success, look for failure

 // Get a password if no valid one was passed to the routine
 // If user cancels, then go no further
 if APass='unknown' then
  PassFlag:=InputQueryDEC('Authentication required for decryption','Type in the decryption password',password)
 else password:=APass;

 If PassFlag then // Password supplied
  begin
   i_RetFlag:=0; // Set error flag to success
   s:=AFile; // Make a copy of the filepath
   Screen.Cursor:=crHourGlass;
   Application.ProcessMessages; // Let windows breathe

   // Call COPYCRYPT.DLL here
   i_Ret:= DecodeSingle(PChar(s),PChar(ExtractFilePath(s)),PChar(password));
   Screen.Cursor:=crDefault;

   // Deal with the return value
   i_RetFlag:=(i_Ret OR i_RetFlag);
   if (i_RetFlag=0) then
    begin
     Application.MessageBox('Selected file(s) decoded successfully',PChar(Caption),4096);
     exit;
     end;
    if ((i_RetFlag AND 1)=1) then
     begin
      Application.MessageBox('One or more decode operations were unsuccessful',PChar(Caption),4096);
     end;
    if ((i_RetFlag AND 2)=2) then
     begin
      Application.MessageBox('One or more passwords were incorrect.',PChar(Caption),4096);
     end;
   end;
END;

(******************************************************************************)
(** END OF USER CODE **)
(******************************************************************************)

procedure Tmainform.cmd_EncodeClick(Sender: TObject);
Var
   s,password:String;
   filecount:LongInt;
   ThisfileNum:longint;
BEGIN
OpenDialog1.Title:='Select file(s) for encryption';
If OpenDialog1.Execute then
 begin
  If InputQueryENC('Encryption Password Input','Choose an encryption password',password) then
    begin
     filecount:=OpenDialog1.Files.Count;
     Screen.Cursor:=crHourGlass;
     For ThisFileNum:=0 to filecount-1 do
      begin
       s:=OpenDialog1.files[ThisFileNum];
       Application.ProcessMessages;
       EncodeSingle(PChar(s),PChar(ChangeFileExt(s,ENCEXT)),PChar(password));
      end;
      Screen.Cursor:=crDefault;
      MessageDlg('Encryption Done.',mtInformation,[MBOK],0);
    end;
 end;
END;

(******************************************************************************)

procedure Tmainform.cmd_DecodeClick(Sender: TObject);
Var
 s,password:String;
 i_Ret,i_RetFlag:Integer;
 filecount:LongInt;
 ThisfileNum:longint;
BEGIN
OpenDialog2.Title:='Select file(s) for decryption';
OpenDialog2.Filter:='CopyCrypted Files (*' + ENCEXT + ')|*' + ENCEXT + '|Any File (*.*)|*.*';
If OpenDialog2.Execute then
 begin
  If InputQueryDEC('Authentication required for decryption','Type in the decryption password',password) then
   begin
    filecount:=OpenDialog2.Files.Count;
    i_RetFlag:=0;
    For ThisFileNum:=0 to filecount-1 do
     begin
          s:=OpenDialog2.files[ThisFileNum];
          Application.ProcessMessages;
          Screen.Cursor:=crHourGlass;
          Application.ProcessMessages;
          i_Ret:= DecodeSingle(PChar(s),PChar(ExtractFilePath(s)),PChar(password));
          i_RetFlag:=(i_Ret OR i_RetFlag);
     end; (** of For-Next loop **)
     Screen.Cursor:=crDefault;
     if (i_RetFlag=0) then
      begin
       Application.MessageBox('Selected file(s) decoded successfully',PChar(Caption),4096);
       exit;
      end;
     if ((i_RetFlag AND 1)=1) then
      begin
        Application.MessageBox('One or more decode operations were unsuccessful',PChar(Caption),4096);
      end;
     if ((i_RetFlag AND 2)=2) then
      begin
       Application.MessageBox('One or more passwords were incorrect.',PChar(Caption),4096);
      end;
   end;
 end;
END;

(******************************************************************************)

procedure Tmainform.FormCreate(Sender: TObject);
CONST
     EXTKEY='CopyCrypt32.File'; //Used to dereference the root entry//
     DEFAULTPASSWORDKEY='\Software\CopyCrypt\DefaultPassword';
Var
   Reg:TRegistry;
   aFile,cmdpass,msg:String;
BEGIN
// Use the Application Icon for everything
Icon:=Application.Icon;
img_Progicon.Picture.Icon:=Application.Icon;

CURRDIR:=ExtractFileDir(ParamStr(0)); //Grab the home directory//
//No BackSlash, even if it's the root directory
If CURRDIR[Length(CURRDIR)]='\' then Delete(CURRDIR,Length(CURRDIR),1);
ChDir(CURRDIR);

// Self-register the filetype
Reg:=TRegistry.Create;
Try //In a resource-protection block//
 With Reg do begin
  RootKey := HKEY_CLASSES_ROOT;       //Work with the associations key
  OpenKey(ENCEXT,true);               //Make/Open the extension key
  WriteString('',EXTKEY);             //Point it to the readable version
  OpenKey('\' + EXTKEY,true);         //Open the readable version
  WriteString('','CopyCrypted File'); //Write ther description for an encrypted file
  WriteString('DefaultIcon','%1');    //And the Icon for an encrypted file
  OpenKey('\' + EXTKEY + '\shell\open\command',true);//Make a command key for an encrypted file
  WriteString('',ParamStr(0) + ' %1');//Use the program + the encrypted file as a parameter
  CloseKey;

  //Let's see if there is a default password defined, shall we?//
  //This stuff affects the InputQueryENC and InputQueryDEC routines//
  RootKey:=HKEY_CURRENT_USER;
  if KeyExists(DEFAULTPASSWORDKEY) then
   begin
    OpenKey(DEFAULTPASSWORDKEY,true);
    REG_DEFAULTPASSWORD:=ReadString('');
    if ReadString('NoPrompt')='yes' then REG_NOPROMPT:=True else REG_NOPROMPT:=False;
    CloseKey;
    if REG_DEFAULTPASSWORD='' then REG_DEFAULTPASSWORD:='unknown';
   end
   else REG_DEFAULTPASSWORD:='unknown';
  //All done.
  //DEBUGGING MessageDlg('Default password is ' +  REG_DEFAULTPASSWORD,mtInformation,[MBOK],0);
 end;
Finally
 Reg.Free;
end;

// Deal with command-line parameter(s)
// Don't bother to show the application, just decode the file
if ParamCount > 0 then //Go on, else skip all of this stuff
 begin

  if ParamCount > 1 then //Is there a 2nd parameter? If so, it's a password.
     cmdpass:=paramstr(2)
  else
      cmdpass:='unknown';//Dummy value to initiate password prompt later

  AFile:=ParamStr(1);//Assume the first paramater is a file to be decoded
  if FileExists(AFile) then//Only go further if the first parameter is a valid file
   begin
    if ExtractFileExt(AFile) = ENCEXT then//Only go further if AFile has the correct extension
      DecodeAFile(AFile,cmdpass)//Everything A-OK. Call Decode and fall through to Terminate
    else
     begin//Just in case. We should never get here under normal use.
      Msg:=AFile + #13 + 'is not of the type "' + ENCEXT + '" which this application';
      Msg := Msg + 'is registered to process.' + #13;
      Msg:=Msg + 'The file type ' + ENCEXT + ' has now been registered for next time.';
      MessageDlg(Msg,mtError,[MBOK],0);
     end;//of extension check
    Application.Terminate;//Always finish under these conditions
   end;//of fileexists check
 end;//of parametercount check

//Needed to enable Drag/Drop from Explorer//
DragAcceptFiles( Handle, True );
END;

(******************************************************************************)

procedure Tmainform.img_ProgiconMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var s:String;
//Simple 'About' dialog
BEGIN
s:='This program (' + Application.EXEName + ')' + #13;
s:=s + ' is a demonstration of practical programming using COPYCRYPT32.DLL.' + #13 + #13;
s:=s + 'Features include:' + #13;
s:= s + '1) Multiple Encode/Decode via Dialog boxes or Drag & Drop' + #13;
s:= s + '2) Registering a file format (' + ENCEXT + ') in the registry' + #13;
s:= s + '3) General routines (EncodeAFile/DecodeAFile) to cut/paste into other apps' + #13;
s:= s + '4) Intelligent Drag/Drop from Explorer/File Manager to Encode/Decode files.';
MessageDlg(s,mtInformation,[MBOK],0);
END;

(******************************************************************************)

procedure Tmainform.cmd_CloseClick(Sender: TObject);
BEGIN
Application.Terminate;
END;

// ENDOFPROGRAM //
END.
